"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AsyncSeries = void 0;
class AsyncSeries {
    constructor(functions, iterator, exceptionHandler) {
        this.functions = functions;
        this.iterator = iterator;
        this.exceptionHandler = exceptionHandler;
        this.functionNum = functions.length;
    }
    async execute(arg) {
        for (let i = 0; i < this.functionNum; i++) {
            try {
                if (this.iterator(arg, this.functions[i], i)) {
                    await this.functions[i].handler(arg);
                }
            }
            catch (e) {
                this.exceptionHandler(arg, e, i);
            }
        }
    }
}
exports.AsyncSeries = AsyncSeries;
