export interface AttachmentKey<T> {
    readonly id: symbol;
    readonly marker: T;
}
export declare class AttachmentRegistry {
    private attachments;
    static createKey<T>(): AttachmentKey<T>;
    putAttachment<T>(key: AttachmentKey<T>, value: T): void;
    deleteAttachment<T>(key: AttachmentKey<T>): void;
    getAttachment<T>(key: AttachmentKey<T>): T | null;
    getAttachmentAssert<T>(key: AttachmentKey<T>): T;
    hasAttachment<T>(key: AttachmentKey<T>): boolean;
    hasAllAttachments(keys: AttachmentKey<any>[]): boolean;
    hasAnyAttachments(keys: AttachmentKey<any>[]): boolean;
}
export declare class MissingAttachmentException extends Error {
    name: string;
    constructor();
}
