/// <reference types="node" />
import { AttachmentRegistry } from "./attachment-registry";
import { ApiRequest, ApiResponse } from "./headers";
export declare type ContentTypeParser = (input: string) => any;
export declare type ContentTypeSerializer = (input: unknown) => string | Buffer;
export declare class ApiContext {
    static defaultContentType: string;
    static requestIdGenerator: () => string;
    private static parserMap;
    private static serializerMap;
    static registerParser(type: string, parser: ContentTypeParser): void;
    static registerSerializer(type: string, serializer: ContentTypeSerializer): void;
    response: ApiResponse;
    readonly attachments: AttachmentRegistry;
    readonly requestId: string;
    readonly request: ApiRequest;
    private serializedResponse;
    constructor(request: Omit<ApiRequest, "body" | "formData" | "queryParams" | "path"> & {
        path: string;
        query: string;
        requestId?: string;
    });
    private static parse;
    private static serialize;
    prepareHeaders(): {
        [name: string]: string;
    };
    responseContentType(): any;
    serializeResponse(): string | Buffer;
}
