"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Controller = void 0;
class Controller {
    constructor() {
        this.statusCode = 200;
        this.statusSet = false;
        this.headers = {};
    }
    setStatus(statusCode) {
        this.statusSet = true;
        this.statusCode = statusCode;
    }
    getStatus() {
        return this.statusCode;
    }
    setHeader(name, value) {
        this.headers[name.toLowerCase()] = value;
    }
    getHeader(name) {
        return this.headers[name];
    }
    getHeaders() {
        return this.headers;
    }
    clearStatus() {
        this.statusSet = false;
        this.statusCode = 200;
    }
    clearHeaders() {
        this.headers = {};
    }
}
exports.Controller = Controller;
