import { ApiMiddleware } from "../lib/common/headers";
export declare function SuccessResponse<HeaderType extends IsValidHeader<HeaderType> = {}>(name: string | number, description?: string): any;
export declare function Response<ExampleType, HeaderType extends IsValidHeader<HeaderType> = {}>(name: string | number, description?: string, example?: ExampleType): any;
export declare function Deprecated(): any;
export declare function Example<T>(exampleModel: T): any;
export declare function Head(value?: string): any;
export declare function Extension(_name: string, _value: ExtensionType | ExtensionType[]): () => void;
export declare type ExtensionType = string | {
    [name: string]: ExtensionType | ExtensionType[];
};
export declare function OperationId(value: string): any;
export declare function NoSecurity(): any;
export declare function Security(name: string | {
    [name: string]: string[];
}, scopes?: string[]): any;
export declare function PrependMiddleware(...middleware: ApiMiddleware[]): any;
export declare function AppendMiddleware(...middleware: ApiMiddleware[]): any;
export declare function Get(name?: string): any;
export declare function Post(name?: string): any;
export declare function Put(name?: string): any;
export declare function Patch(name?: string): any;
export declare function Options(name?: string): any;
export declare function Delete(name?: string): any;
export declare function Body(): any;
export declare function BodyProp(name?: string): any;
export declare function Request(): any;
export declare function Path(name?: string): any;
export declare function Query(name?: string): any;
export declare function Header(name?: string): any;
export declare function Route(name?: string): any;
export declare function Hidden(): any;
export declare function Tags(...values: string[]): any;
export declare type IsValidHeader<HeaderValue> = keyof HeaderValue extends string | number ? HeaderValue[keyof HeaderValue] extends string | string[] | undefined ? {} : 'Header values must be string or string[]' : 'Header names must be of type string';
