import { Valory } from "./valory";
import { ApiMiddleware, HttpMethod } from "../lib/common/headers";
import { AsyncSeries } from "../lib/async-series";
import { ApiContext } from "../lib/common/context";
import { Logger } from "pino";
export declare type RequestExecutorNamespaceHook = (ctx: ApiContext, executor: AsyncSeries<ApiContext, any>) => Promise<void>;
export declare class Endpoint {
    private valory;
    path: string;
    method: HttpMethod;
    static readonly ExceptionKey: import("../lib/common/attachment-registry").AttachmentKey<Error>;
    static readonly RequestLoggerKey: import("../lib/common/attachment-registry").AttachmentKey<Logger>;
    static readonly HandlerLoggerKey: import("../lib/common/attachment-registry").AttachmentKey<Logger>;
    private executor;
    private middleware;
    private logger;
    constructor(valory: Valory, path: string, method: HttpMethod);
    private registerEndpoint;
    private buildExecutor;
    handleRequest(ctx: ApiContext): Promise<ApiContext>;
    appendMiddleware(middleware: ApiMiddleware): this;
    aM(middleware: ApiMiddleware): this;
    appendMiddlewareList(middlewares: ApiMiddleware[]): this;
    aML(middlewares: ApiMiddleware[]): this;
    addDefaultPreMiddleware(): void;
    addDefaultPostMiddleware(): void;
    done(): void;
}
