"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RequestValidator = void 0;
const attachment_registry_1 = require("../../lib/common/attachment-registry");
const NOOP = () => true;
class RequestValidator {
    constructor(valory, path, method) {
        this.name = "RequestValidator";
        this.validator = (method !== "OPTIONS") ? valory.globalData.validation.validators[path][method]["-1"] : NOOP;
    }
    handler(ctx) {
        const result = this.validator(ctx.request);
        if (!result) {
            ctx.attachments.putAttachment(RequestValidator.ValidationErrorsKey, this.validator.errors);
            ctx.response = {
                statusCode: 422,
                body: (typeof this.validator.errors[0] !== "string") ? this.validator.errors.map(RequestValidator.renderError) : this.validator.errors,
                headers: { "Content-Type": "application/json" },
            };
        }
    }
    static renderError(error) {
        return `ValidationError[${error.keyword}]: request${error.dataPath} ${error.message}`;
    }
}
exports.RequestValidator = RequestValidator;
RequestValidator.ValidationErrorsKey = attachment_registry_1.AttachmentRegistry.createKey();
