"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResponseValidator = void 0;
const attachment_registry_1 = require("../../lib/common/attachment-registry");
const global_data_load_1 = require("../../lib/global-data-load");
class ResponseValidator {
    constructor() {
        this.name = "ResponseValidator";
        this.validatorMap = global_data_load_1.loadGlobalData().validation.validators;
    }
    handler(ctx) {
        var _a, _b;
        const validator = (_b = (_a = this.validatorMap[ctx.request.path]) === null || _a === void 0 ? void 0 : _a[ctx.request.method]) === null || _b === void 0 ? void 0 : _b[ctx.response.statusCode || 200];
        const result = validator === null || validator === void 0 ? void 0 : validator(ctx.response);
        if (validator && result !== true) {
            ctx.attachments.putAttachment(ResponseValidator.ResponseValidationErrorsKey, validator.errors);
        }
    }
}
exports.ResponseValidator = ResponseValidator;
ResponseValidator.ResponseValidationErrorsKey = attachment_registry_1.AttachmentRegistry.createKey();
