import { Logger } from "pino";
import { ApiAdaptor } from "../lib/common/headers";
import { RoutesModule, ValoryGlobalData } from "../lib/common/compiler-headers";
import { ApiMiddleware } from "../main";
export interface ValoryArgs {
    beforeAllMiddleware?: ApiMiddleware[];
    afterAllMiddleware?: ApiMiddleware[];
    adaptor: ApiAdaptor;
    baseLogger?: Logger;
}
export declare class Valory {
    private static instance;
    private static directInstantiation;
    readonly adaptor: ApiAdaptor;
    readonly logger: Logger;
    readonly beforeAllMiddleware: ApiMiddleware[];
    readonly afterAllMiddleware: ApiMiddleware[];
    readonly globalData?: ValoryGlobalData;
    static createInstance(args: ValoryArgs): Valory;
    static getInstance(): Valory;
    private constructor();
    private static resolveAdaptor;
    private endpoint;
    start(): any;
    shutdown(): void;
    registerGeneratedRoutes(routes: RoutesModule): void;
}
